package j3d.killTheStudent;

import j3d.utils.Utils;

import javax.media.j3d.*;
import javax.vecmath.Matrix3d;
import javax.vecmath.Point3d;
import javax.vecmath.Vector3d;
import java.awt.*;

import utils.ResourceManager;
import j2d.ImageUtils;

public class JoeSphere {

    public static BranchGroup getLiveJoeSphere(Switch joeSwitch1, Image img) {
        BranchGroup theJoeSphere = new BranchGroup();
        joeSwitch1.addChild(Utils.getTextureSphere(1.5, 0, 1.125, img));
        return theJoeSphere;
    }

    public static BranchGroup getDeadJoeSphere(Image img) {
        BranchGroup theJoeSphere = new BranchGroup();
        theJoeSphere = (j3d.utils.Utils.getTextureSphere(1.5, 0, 1.125, img));
        return theJoeSphere;
    }

    public static Switch getJoeSwitch() {
        Switch s = new Switch(0);
        s.setCapability(Switch.ALLOW_SWITCH_WRITE);
        return s;
    }

    public static BranchGroup getJoeGroup(DoomKeyboard doomKeyboard) {
        BranchGroup theJoeSphere = new BranchGroup();
        ResourceManager rm = ResourceManager.getResourceManager();
        Image img1 = ImageUtils.getImage(rm.getImageFile("face.gif"));
        Image img2 = ImageUtils.getImage(rm.getImageFile("drdiffracto.gif"));

        BranchGroup s1 = getDeadJoeSphere(img2);
        BranchGroup s2 = getLiveJoeSphere(DoomKeyboard.joeSwitch,img1);

        TransformGroup joeRotXfmGrp = new TransformGroup();
        Transform3D joeRotXfm = new Transform3D();
        Matrix3d joeRotMat = new Matrix3d();
        joeRotMat.rotY(Math.PI / 2);
        joeRotXfm.set(joeRotMat, new Vector3d(0.0, 0.0, -30.0), 1.0);
        joeRotXfmGrp.setTransform(joeRotXfm);
        joeRotXfmGrp.addChild(DoomKeyboard.joeSwitch);

        DoomKeyboard.joeSwitch.addChild(s1);
        DoomKeyboard.joeSwitch.addChild(s2);

        TransformGroup joeMovXfmGrp = new TransformGroup();
        joeMovXfmGrp.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        joeMovXfmGrp.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);

        doomKeyboard.keyNavBeh.setTargetTransformGroup(joeMovXfmGrp);
        joeMovXfmGrp.addChild(joeRotXfmGrp);

        Transform3D axis = new Transform3D();
        PositionInterpolator moveJoe =
                new PositionInterpolator(doomKeyboard.joeAlpha,
                        joeMovXfmGrp,
                        axis,
                        -50.0f, 50.0f);
        BoundingSphere bs = new BoundingSphere(new Point3d(0.0, 0.0, 0.0), 200);
        moveJoe.setSchedulingBounds(bs);
        theJoeSphere.addChild(moveJoe);
        theJoeSphere.addChild(joeMovXfmGrp);
        return theJoeSphere;
    }
}
