package net.rmi.rjs.fc.ssinstaller;

import utils.OsUtils;

import java.io.File;


public class SSWindowsInstaller {

    private String windowsSystemDir;
    private File outputJarFile = null;
    private String ssHome;
    private String progress;

    public String createSSHome() {

        ssHome = SSInstallerUtil.getUserHome() + File.separator + SSInstallerUtil.getSSHome();
        try {
            SSInstallerUtil.createDir(ssHome);
        } catch (Exception e) {
            return "Error creating ss home: " + e.toString();
        }
        return "";
    }

    public String beamOverFiles() {

        windowsSystemDir = "";
        if (OsUtils.isWindows98()) {
            windowsSystemDir = "C:" + File.separator +
                    "windows" + File.separator +
                    "system" + File.separator;
        } else if (OsUtils.isWindowsNt()) {
            windowsSystemDir = "C:" + File.separator +
                    "winnt" + File.separator +
                    "system" + File.separator;

        } else {
            windowsSystemDir = "C:" + File.separator +
                    "windows" + File.separator +
                    "system32" + File.separator;
        }

        //Beam over jar file
        outputJarFile = new File(windowsSystemDir + File.separator + SSInstallerUtil.getJarName() + ".jar");
        String urlString = SSInstallerUtil.getSSWinUrl();
        try {
            SSInstallerUtil.downloadScreenSaverJar(outputJarFile, urlString);
        } catch (Exception e) {

            return "Error Downloading Jar File: " + e.toString();
        }

        return "";
    }

    public String uncompressFiles() {
        //	uncompress jar
        try {
            SSInstallerUtil.uncompressScreenSaverJar(outputJarFile);
        } catch (Exception e) {

            return "Error uncompressing Jar File: " + e.toString();
        }

        return "";
    }

    public String install() {

        String isDone = "";
        progress = "... Starting installation" +
                "\n... OS= " + OsUtils.getOsName();

        progress = progress +
                "\n... Reading Properties file";
        //isDone = SSInstallerUtil.readPropertiesfile();
        // // Use if reading properties from a properties file.
        isDone = SSInstallerUtil.setProperties();
        if (isDone != "")
            return isDone;


        isDone = beamOverFiles();
        if (isDone != "")
            return isDone;

        progress = progress +
                "\n... Beaming files over to: " + windowsSystemDir + "... completed";


        isDone = uncompressFiles();
        if (isDone != "") {
            return isDone;
        }
        progress = progress +
                "\n... Uncompressing files... Completed";

        isDone = createSSHome();
        if (isDone != "") {
            return isDone;
        }
        progress = progress +
                "\n... Creating SS home at " + ssHome + "... completed";

        progress = progress +
                "\n... Installation Completed ";

        return "";
    }

    public String getProgress() {

        return progress;
    }
}